diff --git a/_ide_helper.php b/_ide_helper.php
index b307038..7f7a796 100644
--- a/_ide_helper.php
+++ b/_ide_helper.php
@@ -6186,1447 +6453,1510 @@ namespace {
         }
         
         /**
-         * Determine if the request contains a given input item key.
+         * Merge new input into the current request's input array.
          *
-         * @param string|array $key
-         * @return bool 
+         * @param array $input
+         * @return void 
          * @static 
          */
-        public static function exists($key){
-            return \Illuminate\Http\Request::exists($key);
+        public static function merge($input){
+            \Illuminate\Http\Request::merge($input);
         }
         
         /**
-         * Determine if the request contains a non-empty value for an input item.
+         * Replace the input for the current request.
          *
-         * @param string|array $key
-         * @return bool 
+         * @param array $input
+         * @return void 
          * @static 
          */
-        public static function has($key){
-            return \Illuminate\Http\Request::has($key);
+        public static function replace($input){
+            \Illuminate\Http\Request::replace($input);
         }
         
         /**
-         * Get all of the input and files for the request.
+         * Get the JSON payload for the request.
          *
-         * @return array 
+         * @param string $key
+         * @param mixed $default
+         * @return mixed 
          * @static 
          */
-        public static function all(){
-            return \Illuminate\Http\Request::all();
+        public static function json($key = null, $default = null){
+            return \Illuminate\Http\Request::json($key, $default);
         }
         
         /**
-         * Retrieve an input item from the request.
+         * Create an Illuminate request from a Symfony instance.
          *
-         * @param string $key
-         * @param string|array|null $default
-         * @return string|array 
+         * @param \Symfony\Component\HttpFoundation\Request $request
+         * @return \Illuminate\Http\Request 
          * @static 
          */
-        public static function input($key = null, $default = null){
-            return \Illuminate\Http\Request::input($key, $default);
+        public static function createFromBase($request){
+            return \Illuminate\Http\Request::createFromBase($request);
         }
         
         /**
-         * Get a subset containing the provided keys with values from the input data.
+         * Clones a request and overrides some of its parameters.
          *
-         * @param array|mixed $keys
-         * @return array 
+         * @param array $query The GET parameters
+         * @param array $request The POST parameters
+         * @param array $attributes The request attributes (parameters parsed from the PATH_INFO, ...)
+         * @param array $cookies The COOKIE parameters
+         * @param array $files The FILES parameters
+         * @param array $server The SERVER parameters
+         * @return static 
          * @static 
          */
-        public static function only($keys){
-            return \Illuminate\Http\Request::only($keys);
+        public static function duplicate($query = null, $request = null, $attributes = null, $cookies = null, $files = null, $server = null){
+            return \Illuminate\Http\Request::duplicate($query, $request, $attributes, $cookies, $files, $server);
         }
         
         /**
-         * Get all of the input except for a specified array of items.
+         * Get the session associated with the request.
          *
-         * @param array|mixed $keys
-         * @return array 
+         * @return \Illuminate\Session\Store 
+         * @throws \RuntimeException
          * @static 
          */
-        public static function except($keys){
-            return \Illuminate\Http\Request::except($keys);
+        public static function session(){
+            return \Illuminate\Http\Request::session();
         }
         
         /**
-         * Intersect an array of items with the input data.
+         * Set the session instance on the request.
          *
-         * @param array|mixed $keys
-         * @return array 
+         * @param \Illuminate\Contracts\Session\Session $session
+         * @return void 
          * @static 
          */
-        public static function intersect($keys){
-            return \Illuminate\Http\Request::intersect($keys);
+        public static function setLaravelSession($session){
+            \Illuminate\Http\Request::setLaravelSession($session);
         }
         
         /**
-         * Retrieve a query string item from the request.
+         * Get the user making the request.
          *
-         * @param string $key
-         * @param string|array|null $default
-         * @return string|array 
+         * @param string|null $guard
+         * @return mixed 
          * @static 
          */
-        public static function query($key = null, $default = null){
-            return \Illuminate\Http\Request::query($key, $default);
+        public static function user($guard = null){
+            return \Illuminate\Http\Request::user($guard);
         }
         
         /**
-         * Determine if a cookie is set on the request.
+         * Get the route handling the request.
          *
-         * @param string $key
-         * @return bool 
+         * @param string|null $param
+         * @return \Illuminate\Routing\Route|object|string 
          * @static 
          */
-        public static function hasCookie($key){
-            return \Illuminate\Http\Request::hasCookie($key);
+        public static function route($param = null){
+            return \Illuminate\Http\Request::route($param);
         }
         
         /**
-         * Retrieve a cookie from the request.
+         * Get a unique fingerprint for the request / route / IP address.
          *
-         * @param string $key
-         * @param string|array|null $default
-         * @return string|array 
+         * @return string 
+         * @throws \RuntimeException
          * @static 
          */
-        public static function cookie($key = null, $default = null){
-            return \Illuminate\Http\Request::cookie($key, $default);
+        public static function fingerprint(){
+            return \Illuminate\Http\Request::fingerprint();
         }
         
         /**
-         * Get an array of all of the files on the request.
+         * Set the JSON payload for the request.
          *
-         * @return array 
+         * @param array $json
+         * @return $this 
          * @static 
          */
-        public static function allFiles(){
-            return \Illuminate\Http\Request::allFiles();
+        public static function setJson($json){
+            return \Illuminate\Http\Request::setJson($json);
         }
         
         /**
-         * Retrieve a file from the request.
+         * Get the user resolver callback.
          *
-         * @param string $key
-         * @param mixed $default
-         * @return \Illuminate\Http\UploadedFile|array|null 
+         * @return \Closure 
          * @static 
          */
-        public static function file($key = null, $default = null){
-            return \Illuminate\Http\Request::file($key, $default);
+        public static function getUserResolver(){
+            return \Illuminate\Http\Request::getUserResolver();
         }
         
         /**
-         * Determine if the uploaded data contains a file.
+         * Set the user resolver callback.
          *
-         * @param string $key
-         * @return bool 
+         * @param \Closure $callback
+         * @return $this 
          * @static 
          */
-        public static function hasFile($key){
-            return \Illuminate\Http\Request::hasFile($key);
+        public static function setUserResolver($callback){
+            return \Illuminate\Http\Request::setUserResolver($callback);
         }
         
         /**
-         * Determine if a header is set on the request.
+         * Get the route resolver callback.
          *
-         * @param string $key
-         * @return bool 
+         * @return \Closure 
          * @static 
          */
-        public static function hasHeader($key){
-            return \Illuminate\Http\Request::hasHeader($key);
+        public static function getRouteResolver(){
+            return \Illuminate\Http\Request::getRouteResolver();
         }
         
         /**
-         * Retrieve a header from the request.
+         * Set the route resolver callback.
          *
-         * @param string $key
-         * @param string|array|null $default
-         * @return string|array 
+         * @param \Closure $callback
+         * @return $this 
          * @static 
          */
-        public static function header($key = null, $default = null){
-            return \Illuminate\Http\Request::header($key, $default);
+        public static function setRouteResolver($callback){
+            return \Illuminate\Http\Request::setRouteResolver($callback);
         }
         
         /**
-         * Retrieve a server variable from the request.
+         * Get all of the input and files for the request.
          *
-         * @param string $key
-         * @param string|array|null $default
-         * @return string|array 
+         * @return array 
          * @static 
          */
-        public static function server($key = null, $default = null){
-            return \Illuminate\Http\Request::server($key, $default);
+        public static function toArray(){
+            return \Illuminate\Http\Request::toArray();
         }
         
         /**
-         * Retrieve an old input item.
+         * Determine if the given offset exists.
          *
-         * @param string $key
-         * @param string|array|null $default
-         * @return string|array 
+         * @param string $offset
+         * @return bool 
          * @static 
          */
-        public static function old($key = null, $default = null){
-            return \Illuminate\Http\Request::old($key, $default);
+        public static function offsetExists($offset){
+            return \Illuminate\Http\Request::offsetExists($offset);
         }
         
         /**
-         * Flash the input for the current request to the session.
+         * Get the value at the given offset.
          *
-         * @param string $filter
-         * @param array $keys
-         * @return void 
+         * @param string $offset
+         * @return mixed 
          * @static 
          */
-        public static function flash($filter = null, $keys = array()){
-            \Illuminate\Http\Request::flash($filter, $keys);
+        public static function offsetGet($offset){
+            return \Illuminate\Http\Request::offsetGet($offset);
         }
         
         /**
-         * Flash only some of the input to the session.
+         * Set the value at the given offset.
          *
-         * @param array|mixed $keys
+         * @param string $offset
+         * @param mixed $value
          * @return void 
          * @static 
          */
-        public static function flashOnly($keys){
-            \Illuminate\Http\Request::flashOnly($keys);
+        public static function offsetSet($offset, $value){
+            \Illuminate\Http\Request::offsetSet($offset, $value);
         }
         
         /**
-         * Flash only some of the input to the session.
+         * Remove the value at the given offset.
          *
-         * @param array|mixed $keys
+         * @param string $offset
          * @return void 
          * @static 
          */
-        public static function flashExcept($keys){
-            \Illuminate\Http\Request::flashExcept($keys);
+        public static function offsetUnset($offset){
+            \Illuminate\Http\Request::offsetUnset($offset);
         }
         
         /**
-         * Flush all of the old input from the session.
+         * Sets the parameters for this request.
+         * 
+         * This method also re-initializes all properties.
          *
-         * @return void 
+         * @param array $query The GET parameters
+         * @param array $request The POST parameters
+         * @param array $attributes The request attributes (parameters parsed from the PATH_INFO, ...)
+         * @param array $cookies The COOKIE parameters
+         * @param array $files The FILES parameters
+         * @param array $server The SERVER parameters
+         * @param string|resource $content The raw body data
          * @static 
          */
-        public static function flush(){
-            \Illuminate\Http\Request::flush();
+        public static function initialize($query = array(), $request = array(), $attributes = array(), $cookies = array(), $files = array(), $server = array(), $content = null){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::initialize($query, $request, $attributes, $cookies, $files, $server, $content);
         }
         
         /**
-         * Merge new input into the current request's input array.
+         * Creates a new request with values from PHP's super globals.
          *
-         * @param array $input
-         * @return void 
+         * @return static 
          * @static 
          */
-        public static function merge($input){
-            \Illuminate\Http\Request::merge($input);
+        public static function createFromGlobals(){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::createFromGlobals();
         }
         
         /**
-         * Replace the input for the current request.
+         * Creates a Request based on a given URI and configuration.
+         * 
+         * The information contained in the URI always take precedence
+         * over the other information (server and parameters).
          *
-         * @param array $input
-         * @return void 
+         * @param string $uri The URI
+         * @param string $method The HTTP method
+         * @param array $parameters The query (GET) or request (POST) parameters
+         * @param array $cookies The request cookies ($_COOKIE)
+         * @param array $files The request files ($_FILES)
+         * @param array $server The server parameters ($_SERVER)
+         * @param string $content The raw body data
+         * @return static 
          * @static 
          */
-        public static function replace($input){
-            \Illuminate\Http\Request::replace($input);
+        public static function create($uri, $method = 'GET', $parameters = array(), $cookies = array(), $files = array(), $server = array(), $content = null){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::create($uri, $method, $parameters, $cookies, $files, $server, $content);
         }
         
         /**
-         * Get the JSON payload for the request.
+         * Sets a callable able to create a Request instance.
+         * 
+         * This is mainly useful when you need to override the Request class
+         * to keep BC with an existing system. It should not be used for any
+         * other purpose.
          *
-         * @param string $key
-         * @param mixed $default
-         * @return mixed 
+         * @param callable|null $callable A PHP callable
          * @static 
          */
-        public static function json($key = null, $default = null){
-            return \Illuminate\Http\Request::json($key, $default);
+        public static function setFactory($callable){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::setFactory($callable);
         }
         
         /**
-         * Determine if the given content types match.
+         * Overrides the PHP global variables according to this request instance.
+         * 
+         * It overrides $_GET, $_POST, $_REQUEST, $_SERVER, $_COOKIE.
+         * $_FILES is never overridden, see rfc1867
          *
-         * @param string $actual
-         * @param string $type
-         * @return bool 
          * @static 
          */
-        public static function matchesType($actual, $type){
-            return \Illuminate\Http\Request::matchesType($actual, $type);
+        public static function overrideGlobals(){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::overrideGlobals();
         }
         
         /**
-         * Determine if the request is sending JSON.
+         * Sets a list of trusted proxies.
+         * 
+         * You should only list the reverse proxies that you manage directly.
          *
-         * @return bool 
+         * @param array $proxies A list of trusted proxies
+         * @param int $trustedHeaderSet A bit field of Request::HEADER_*, to set which headers to trust from your proxies
+         * @throws \InvalidArgumentException When $trustedHeaderSet is invalid
          * @static 
          */
-        public static function isJson(){
-            return \Illuminate\Http\Request::isJson();
+        public static function setTrustedProxies($proxies){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::setTrustedProxies($proxies);
         }
         
         /**
-         * Determine if the current request probably expects a JSON response.
+         * Gets the list of trusted proxies.
          *
-         * @return bool 
+         * @return array An array of trusted proxies
          * @static 
          */
-        public static function expectsJson(){
-            return \Illuminate\Http\Request::expectsJson();
+        public static function getTrustedProxies(){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::getTrustedProxies();
         }
         
         /**
-         * Determine if the current request is asking for JSON in return.
+         * Gets the set of trusted headers from trusted proxies.
          *
-         * @return bool 
+         * @return int A bit field of Request::HEADER_* that defines which headers are trusted from your proxies
          * @static 
          */
-        public static function wantsJson(){
-            return \Illuminate\Http\Request::wantsJson();
+        public static function getTrustedHeaderSet(){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::getTrustedHeaderSet();
         }
         
         /**
-         * Determines whether the current requests accepts a given content type.
+         * Sets a list of trusted host patterns.
+         * 
+         * You should only list the hosts you manage using regexs.
          *
-         * @param string|array $contentTypes
-         * @return bool 
+         * @param array $hostPatterns A list of trusted host patterns
          * @static 
          */
-        public static function accepts($contentTypes){
-            return \Illuminate\Http\Request::accepts($contentTypes);
+        public static function setTrustedHosts($hostPatterns){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::setTrustedHosts($hostPatterns);
         }
         
         /**
-         * Return the most suitable content type from the given array based on content negotiation.
+         * Gets the list of trusted host patterns.
          *
-         * @param string|array $contentTypes
-         * @return string|null 
+         * @return array An array of trusted host patterns
          * @static 
          */
-        public static function prefers($contentTypes){
-            return \Illuminate\Http\Request::prefers($contentTypes);
+        public static function getTrustedHosts(){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::getTrustedHosts();
         }
         
         /**
-         * Determines whether a request accepts JSON.
+         * Sets the name for trusted headers.
+         * 
+         * The following header keys are supported:
+         * 
+         *  * Request::HEADER_CLIENT_IP:    defaults to X-Forwarded-For   (see getClientIp())
+         *  * Request::HEADER_CLIENT_HOST:  defaults to X-Forwarded-Host  (see getHost())
+         *  * Request::HEADER_CLIENT_PORT:  defaults to X-Forwarded-Port  (see getPort())
+         *  * Request::HEADER_CLIENT_PROTO: defaults to X-Forwarded-Proto (see getScheme() and isSecure())
+         *  * Request::HEADER_FORWARDED:    defaults to Forwarded         (see RFC 7239)
+         * 
+         * Setting an empty value allows to disable the trusted header for the given key.
          *
-         * @return bool 
+         * @param string $key The header key
+         * @param string $value The header name
+         * @throws \InvalidArgumentException
+         * @deprecated since version 3.3, to be removed in 4.0. Use the $trustedHeaderSet argument of the Request::setTrustedProxies() method instead.
          * @static 
          */
-        public static function acceptsJson(){
-            return \Illuminate\Http\Request::acceptsJson();
+        public static function setTrustedHeaderName($key, $value){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::setTrustedHeaderName($key, $value);
         }
         
         /**
-         * Determines whether a request accepts HTML.
+         * Gets the trusted proxy header name.
          *
-         * @return bool 
+         * @param string $key The header key
+         * @return string The header name
+         * @throws \InvalidArgumentException
+         * @deprecated since version 3.3, to be removed in 4.0. Use the Request::getTrustedHeaderSet() method instead.
          * @static 
          */
-        public static function acceptsHtml(){
-            return \Illuminate\Http\Request::acceptsHtml();
+        public static function getTrustedHeaderName($key){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::getTrustedHeaderName($key);
         }
         
         /**
-         * Get the data format expected in the response.
+         * Normalizes a query string.
+         * 
+         * It builds a normalized query string, where keys/value pairs are alphabetized,
+         * have consistent escaping and unneeded delimiters are removed.
          *
-         * @param string $default
-         * @return string 
+         * @param string $qs Query string
+         * @return string A normalized query string for the Request
          * @static 
          */
-        public static function format($default = 'html'){
-            return \Illuminate\Http\Request::format($default);
+        public static function normalizeQueryString($qs){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::normalizeQueryString($qs);
         }
         
         /**
-         * Get the bearer token from the request headers.
+         * Enables support for the _method request parameter to determine the intended HTTP method.
+         * 
+         * Be warned that enabling this feature might lead to CSRF issues in your code.
+         * Check that you are using CSRF tokens when required.
+         * If the HTTP method parameter override is enabled, an html-form with method "POST" can be altered
+         * and used to send a "PUT" or "DELETE" request via the _method request parameter.
+         * If these methods are not protected against CSRF, this presents a possible vulnerability.
+         * 
+         * The HTTP method can only be overridden when the real HTTP method is POST.
          *
-         * @return string|null 
          * @static 
          */
-        public static function bearerToken(){
-            return \Illuminate\Http\Request::bearerToken();
+        public static function enableHttpMethodParameterOverride(){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::enableHttpMethodParameterOverride();
         }
         
         /**
-         * Create an Illuminate request from a Symfony instance.
+         * Checks whether support for the _method request parameter is enabled.
          *
-         * @param \Symfony\Component\HttpFoundation\Request $request
-         * @return \Illuminate\Http\Request 
+         * @return bool True when the _method request parameter is enabled, false otherwise
          * @static 
          */
-        public static function createFromBase($request){
-            return \Illuminate\Http\Request::createFromBase($request);
+        public static function getHttpMethodParameterOverride(){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::getHttpMethodParameterOverride();
         }
         
         /**
-         * Clones a request and overrides some of its parameters.
+         * Gets a "parameter" value from any bag.
+         * 
+         * This method is mainly useful for libraries that want to provide some flexibility. If you don't need the
+         * flexibility in controllers, it is better to explicitly get request parameters from the appropriate
+         * public property instead (attributes, query, request).
+         * 
+         * Order of precedence: PATH (routing placeholders or custom attributes), GET, BODY
          *
-         * @param array $query The GET parameters
-         * @param array $request The POST parameters
-         * @param array $attributes The request attributes (parameters parsed from the PATH_INFO, ...)
-         * @param array $cookies The COOKIE parameters
-         * @param array $files The FILES parameters
-         * @param array $server The SERVER parameters
-         * @return \Request The duplicated request
+         * @param string $key the key
+         * @param mixed $default the default value if the parameter key does not exist
+         * @return mixed 
          * @static 
          */
-        public static function duplicate($query = null, $request = null, $attributes = null, $cookies = null, $files = null, $server = null){
-            return \Illuminate\Http\Request::duplicate($query, $request, $attributes, $cookies, $files, $server);
+        public static function get($key, $default = null){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::get($key, $default);
         }
         
         /**
-         * Get the session associated with the request.
+         * Gets the Session.
          *
-         * @return \Illuminate\Session\Store 
-         * @throws \RuntimeException
+         * @return \Symfony\Component\HttpFoundation\SessionInterface|null The session
          * @static 
          */
-        public static function session(){
-            return \Illuminate\Http\Request::session();
+        public static function getSession(){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::getSession();
         }
         
         /**
-         * Get the user making the request.
+         * Whether the request contains a Session which was started in one of the
+         * previous requests.
          *
-         * @param string|null $guard
-         * @return mixed 
+         * @return bool 
          * @static 
          */
-        public static function user($guard = null){
-            return \Illuminate\Http\Request::user($guard);
+        public static function hasPreviousSession(){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::hasPreviousSession();
         }
         
         /**
-         * Get the route handling the request.
+         * Whether the request contains a Session object.
+         * 
+         * This method does not give any information about the state of the session object,
+         * like whether the session is started or not. It is just a way to check if this Request
+         * is associated with a Session instance.
          *
-         * @param string|null $param
-         * @return \Illuminate\Routing\Route|object|string 
+         * @return bool true when the Request contains a Session object, false otherwise
          * @static 
          */
-        public static function route($param = null){
-            return \Illuminate\Http\Request::route($param);
+        public static function hasSession(){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::hasSession();
         }
         
         /**
-         * Get a unique fingerprint for the request / route / IP address.
+         * Sets the Session.
          *
-         * @return string 
-         * @throws \RuntimeException
+         * @param \Symfony\Component\HttpFoundation\SessionInterface $session The Session
          * @static 
          */
-        public static function fingerprint(){
-            return \Illuminate\Http\Request::fingerprint();
+        public static function setSession($session){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::setSession($session);
         }
         
         /**
-         * Get the user resolver callback.
+         * Returns the client IP addresses.
+         * 
+         * In the returned array the most trusted IP address is first, and the
+         * least trusted one last. The "real" client IP address is the last one,
+         * but this is also the least trusted one. Trusted proxies are stripped.
+         * 
+         * Use this method carefully; you should use getClientIp() instead.
          *
-         * @return \Closure 
+         * @return array The client IP addresses
+         * @see getClientIp()
          * @static 
          */
-        public static function getUserResolver(){
-            return \Illuminate\Http\Request::getUserResolver();
+        public static function getClientIps(){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::getClientIps();
         }
         
         /**
-         * Set the user resolver callback.
+         * Returns the client IP address.
+         * 
+         * This method can read the client IP address from the "X-Forwarded-For" header
+         * when trusted proxies were set via "setTrustedProxies()". The "X-Forwarded-For"
+         * header value is a comma+space separated list of IP addresses, the left-most
+         * being the original client, and each successive proxy that passed the request
+         * adding the IP address where it received the request from.
+         * 
+         * If your reverse proxy uses a different header name than "X-Forwarded-For",
+         * ("Client-Ip" for instance), configure it via the $trustedHeaderSet
+         * argument of the Request::setTrustedProxies() method instead.
          *
-         * @param \Closure $callback
-         * @return $this 
+         * @return string|null The client IP address
+         * @see getClientIps()
+         * @see http://en.wikipedia.org/wiki/X-Forwarded-For
          * @static 
          */
-        public static function setUserResolver($callback){
-            return \Illuminate\Http\Request::setUserResolver($callback);
+        public static function getClientIp(){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::getClientIp();
         }
         
         /**
-         * Get the route resolver callback.
+         * Returns current script name.
          *
-         * @return \Closure 
+         * @return string 
          * @static 
          */
-        public static function getRouteResolver(){
-            return \Illuminate\Http\Request::getRouteResolver();
+        public static function getScriptName(){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::getScriptName();
         }
         
         /**
-         * Set the route resolver callback.
+         * Returns the path being requested relative to the executed script.
+         * 
+         * The path info always starts with a /.
+         * 
+         * Suppose this request is instantiated from /mysite on localhost:
+         * 
+         *  * http://localhost/mysite              returns an empty string
+         *  * http://localhost/mysite/about        returns '/about'
+         *  * http://localhost/mysite/enco%20ded   returns '/enco%20ded'
+         *  * http://localhost/mysite/about?var=1  returns '/about'
          *
-         * @param \Closure $callback
-         * @return $this 
+         * @return string The raw path (i.e. not urldecoded)
          * @static 
          */
-        public static function setRouteResolver($callback){
-            return \Illuminate\Http\Request::setRouteResolver($callback);
+        public static function getPathInfo(){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::getPathInfo();
         }
         
         /**
-         * Get all of the input and files for the request.
+         * Returns the root path from which this request is executed.
+         * 
+         * Suppose that an index.php file instantiates this request object:
+         * 
+         *  * http://localhost/index.php         returns an empty string
+         *  * http://localhost/index.php/page    returns an empty string
+         *  * http://localhost/web/index.php     returns '/web'
+         *  * http://localhost/we%20b/index.php  returns '/we%20b'
          *
-         * @return array 
+         * @return string The raw path (i.e. not urldecoded)
          * @static 
          */
-        public static function toArray(){
-            return \Illuminate\Http\Request::toArray();
+        public static function getBasePath(){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::getBasePath();
         }
         
         /**
-         * Determine if the given offset exists.
+         * Returns the root URL from which this request is executed.
+         * 
+         * The base URL never ends with a /.
+         * 
+         * This is similar to getBasePath(), except that it also includes the
+         * script filename (e.g. index.php) if one exists.
          *
-         * @param string $offset
-         * @return bool 
+         * @return string The raw URL (i.e. not urldecoded)
          * @static 
          */
-        public static function offsetExists($offset){
-            return \Illuminate\Http\Request::offsetExists($offset);
+        public static function getBaseUrl(){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::getBaseUrl();
         }
         
         /**
-         * Get the value at the given offset.
+         * Gets the request's scheme.
          *
-         * @param string $offset
-         * @return mixed 
+         * @return string 
          * @static 
          */
-        public static function offsetGet($offset){
-            return \Illuminate\Http\Request::offsetGet($offset);
+        public static function getScheme(){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::getScheme();
         }
         
         /**
-         * Set the value at the given offset.
+         * Returns the port on which the request is made.
+         * 
+         * This method can read the client port from the "X-Forwarded-Port" header
+         * when trusted proxies were set via "setTrustedProxies()".
+         * 
+         * The "X-Forwarded-Port" header must contain the client port.
+         * 
+         * If your reverse proxy uses a different header name than "X-Forwarded-Port",
+         * configure it via via the $trustedHeaderSet argument of the
+         * Request::setTrustedProxies() method instead.
          *
-         * @param string $offset
-         * @param mixed $value
-         * @return void 
+         * @return int|string can be a string if fetched from the server bag
          * @static 
          */
-        public static function offsetSet($offset, $value){
-            \Illuminate\Http\Request::offsetSet($offset, $value);
+        public static function getPort(){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::getPort();
         }
         
         /**
-         * Remove the value at the given offset.
+         * Returns the user.
          *
-         * @param string $offset
-         * @return void 
+         * @return string|null 
          * @static 
          */
-        public static function offsetUnset($offset){
-            \Illuminate\Http\Request::offsetUnset($offset);
+        public static function getUser(){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::getUser();
         }
         
         /**
-         * Sets the parameters for this request.
-         * 
-         * This method also re-initializes all properties.
+         * Returns the password.
          *
-         * @param array $query The GET parameters
-         * @param array $request The POST parameters
-         * @param array $attributes The request attributes (parameters parsed from the PATH_INFO, ...)
-         * @param array $cookies The COOKIE parameters
-         * @param array $files The FILES parameters
-         * @param array $server The SERVER parameters
-         * @param string|resource $content The raw body data
+         * @return string|null 
          * @static 
          */
-        public static function initialize($query = array(), $request = array(), $attributes = array(), $cookies = array(), $files = array(), $server = array(), $content = null){
+        public static function getPassword(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::initialize($query, $request, $attributes, $cookies, $files, $server, $content);
+            return \Illuminate\Http\Request::getPassword();
         }
         
         /**
-         * Creates a new request with values from PHP's super globals.
+         * Gets the user info.
          *
-         * @return \Request A new request
+         * @return string A user name and, optionally, scheme-specific information about how to gain authorization to access the server
          * @static 
          */
-        public static function createFromGlobals(){
+        public static function getUserInfo(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::createFromGlobals();
+            return \Illuminate\Http\Request::getUserInfo();
         }
         
         /**
-         * Creates a Request based on a given URI and configuration.
+         * Returns the HTTP host being requested.
          * 
-         * The information contained in the URI always take precedence
-         * over the other information (server and parameters).
+         * The port name will be appended to the host if it's non-standard.
          *
-         * @param string $uri The URI
-         * @param string $method The HTTP method
-         * @param array $parameters The query (GET) or request (POST) parameters
-         * @param array $cookies The request cookies ($_COOKIE)
-         * @param array $files The request files ($_FILES)
-         * @param array $server The server parameters ($_SERVER)
-         * @param string $content The raw body data
-         * @return \Request A Request instance
+         * @return string 
          * @static 
          */
-        public static function create($uri, $method = 'GET', $parameters = array(), $cookies = array(), $files = array(), $server = array(), $content = null){
+        public static function getHttpHost(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::create($uri, $method, $parameters, $cookies, $files, $server, $content);
+            return \Illuminate\Http\Request::getHttpHost();
         }
         
         /**
-         * Sets a callable able to create a Request instance.
-         * 
-         * This is mainly useful when you need to override the Request class
-         * to keep BC with an existing system. It should not be used for any
-         * other purpose.
+         * Returns the requested URI (path and query string).
          *
-         * @param callable|null $callable A PHP callable
+         * @return string The raw URI (i.e. not URI decoded)
          * @static 
          */
-        public static function setFactory($callable){
+        public static function getRequestUri(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::setFactory($callable);
+            return \Illuminate\Http\Request::getRequestUri();
         }
         
         /**
-         * Overrides the PHP global variables according to this request instance.
+         * Gets the scheme and HTTP host.
          * 
-         * It overrides $_GET, $_POST, $_REQUEST, $_SERVER, $_COOKIE.
-         * $_FILES is never overridden, see rfc1867
+         * If the URL was called with basic authentication, the user
+         * and the password are not added to the generated string.
          *
+         * @return string The scheme and HTTP host
          * @static 
          */
-        public static function overrideGlobals(){
+        public static function getSchemeAndHttpHost(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::overrideGlobals();
+            return \Illuminate\Http\Request::getSchemeAndHttpHost();
         }
         
         /**
-         * Sets a list of trusted proxies.
-         * 
-         * You should only list the reverse proxies that you manage directly.
+         * Generates a normalized URI (URL) for the Request.
          *
-         * @param array $proxies A list of trusted proxies
+         * @return string A normalized URI (URL) for the Request
+         * @see getQueryString()
          * @static 
          */
-        public static function setTrustedProxies($proxies){
+        public static function getUri(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::setTrustedProxies($proxies);
+            return \Illuminate\Http\Request::getUri();
         }
         
         /**
-         * Gets the list of trusted proxies.
+         * Generates a normalized URI for the given path.
          *
-         * @return array An array of trusted proxies
+         * @param string $path A path to use instead of the current one
+         * @return string The normalized URI for the path
          * @static 
          */
-        public static function getTrustedProxies(){
+        public static function getUriForPath($path){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getTrustedProxies();
+            return \Illuminate\Http\Request::getUriForPath($path);
         }
         
         /**
-         * Sets a list of trusted host patterns.
+         * Returns the path as relative reference from the current Request path.
          * 
-         * You should only list the hosts you manage using regexs.
+         * Only the URIs path component (no schema, host etc.) is relevant and must be given.
+         * Both paths must be absolute and not contain relative parts.
+         * Relative URLs from one resource to another are useful when generating self-contained downloadable document archives.
+         * Furthermore, they can be used to reduce the link size in documents.
+         * 
+         * Example target paths, given a base path of "/a/b/c/d":
+         * - "/a/b/c/d"     -> ""
+         * - "/a/b/c/"      -> "./"
+         * - "/a/b/"        -> "../"
+         * - "/a/b/c/other" -> "other"
+         * - "/a/x/y"       -> "../../x/y"
          *
-         * @param array $hostPatterns A list of trusted host patterns
+         * @param string $path The target path
+         * @return string The relative target path
          * @static 
          */
-        public static function setTrustedHosts($hostPatterns){
+        public static function getRelativeUriForPath($path){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::setTrustedHosts($hostPatterns);
+            return \Illuminate\Http\Request::getRelativeUriForPath($path);
         }
         
         /**
-         * Gets the list of trusted host patterns.
+         * Generates the normalized query string for the Request.
+         * 
+         * It builds a normalized query string, where keys/value pairs are alphabetized
+         * and have consistent escaping.
          *
-         * @return array An array of trusted host patterns
+         * @return string|null A normalized query string for the Request
          * @static 
          */
-        public static function getTrustedHosts(){
+        public static function getQueryString(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getTrustedHosts();
+            return \Illuminate\Http\Request::getQueryString();
         }
         
         /**
-         * Sets the name for trusted headers.
+         * Checks whether the request is secure or not.
          * 
-         * The following header keys are supported:
+         * This method can read the client protocol from the "X-Forwarded-Proto" header
+         * when trusted proxies were set via "setTrustedProxies()".
          * 
-         *  * Request::HEADER_CLIENT_IP:    defaults to X-Forwarded-For   (see getClientIp())
-         *  * Request::HEADER_CLIENT_HOST:  defaults to X-Forwarded-Host  (see getHost())
-         *  * Request::HEADER_CLIENT_PORT:  defaults to X-Forwarded-Port  (see getPort())
-         *  * Request::HEADER_CLIENT_PROTO: defaults to X-Forwarded-Proto (see getScheme() and isSecure())
+         * The "X-Forwarded-Proto" header must contain the protocol: "https" or "http".
          * 
-         * Setting an empty value allows to disable the trusted header for the given key.
+         * If your reverse proxy uses a different header name than "X-Forwarded-Proto"
+         * ("SSL_HTTPS" for instance), configure it via the $trustedHeaderSet
+         * argument of the Request::setTrustedProxies() method instead.
          *
-         * @param string $key The header key
-         * @param string $value The header name
-         * @throws \InvalidArgumentException
+         * @return bool 
          * @static 
          */
-        public static function setTrustedHeaderName($key, $value){
+        public static function isSecure(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::setTrustedHeaderName($key, $value);
+            return \Illuminate\Http\Request::isSecure();
         }
         
         /**
-         * Gets the trusted proxy header name.
+         * Returns the host name.
+         * 
+         * This method can read the client host name from the "X-Forwarded-Host" header
+         * when trusted proxies were set via "setTrustedProxies()".
+         * 
+         * The "X-Forwarded-Host" header must contain the client host name.
+         * 
+         * If your reverse proxy uses a different header name than "X-Forwarded-Host",
+         * configure it via the $trustedHeaderSet argument of the
+         * Request::setTrustedProxies() method instead.
          *
-         * @param string $key The header key
-         * @return string The header name
-         * @throws \InvalidArgumentException
+         * @return string 
+         * @throws SuspiciousOperationException when the host name is invalid or not trusted
          * @static 
          */
-        public static function getTrustedHeaderName($key){
+        public static function getHost(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getTrustedHeaderName($key);
+            return \Illuminate\Http\Request::getHost();
         }
         
         /**
-         * Normalizes a query string.
-         * 
-         * It builds a normalized query string, where keys/value pairs are alphabetized,
-         * have consistent escaping and unneeded delimiters are removed.
+         * Sets the request method.
          *
-         * @param string $qs Query string
-         * @return string A normalized query string for the Request
+         * @param string $method
          * @static 
          */
-        public static function normalizeQueryString($qs){
+        public static function setMethod($method){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::normalizeQueryString($qs);
+            return \Illuminate\Http\Request::setMethod($method);
         }
         
         /**
-         * Enables support for the _method request parameter to determine the intended HTTP method.
+         * Gets the request "intended" method.
          * 
-         * Be warned that enabling this feature might lead to CSRF issues in your code.
-         * Check that you are using CSRF tokens when required.
-         * If the HTTP method parameter override is enabled, an html-form with method "POST" can be altered
-         * and used to send a "PUT" or "DELETE" request via the _method request parameter.
-         * If these methods are not protected against CSRF, this presents a possible vulnerability.
+         * If the X-HTTP-Method-Override header is set, and if the method is a POST,
+         * then it is used to determine the "real" intended HTTP method.
          * 
-         * The HTTP method can only be overridden when the real HTTP method is POST.
+         * The _method request parameter can also be used to determine the HTTP method,
+         * but only if enableHttpMethodParameterOverride() has been called.
+         * 
+         * The method is always an uppercased string.
          *
+         * @return string The request method
+         * @see getRealMethod()
          * @static 
          */
-        public static function enableHttpMethodParameterOverride(){
+        public static function getMethod(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::enableHttpMethodParameterOverride();
+            return \Illuminate\Http\Request::getMethod();
         }
         
         /**
-         * Checks whether support for the _method request parameter is enabled.
+         * Gets the "real" request method.
          *
-         * @return bool True when the _method request parameter is enabled, false otherwise
+         * @return string The request method
+         * @see getMethod()
          * @static 
          */
-        public static function getHttpMethodParameterOverride(){
+        public static function getRealMethod(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getHttpMethodParameterOverride();
+            return \Illuminate\Http\Request::getRealMethod();
         }
         
         /**
-         * Gets a "parameter" value from any bag.
-         * 
-         * This method is mainly useful for libraries that want to provide some flexibility. If you don't need the
-         * flexibility in controllers, it is better to explicitly get request parameters from the appropriate
-         * public property instead (attributes, query, request).
-         * 
-         * Order of precedence: PATH (routing placeholders or custom attributes), GET, BODY
+         * Gets the mime type associated with the format.
          *
-         * @param string $key the key
-         * @param mixed $default the default value if the parameter key does not exist
-         * @return mixed 
+         * @param string $format The format
+         * @return string The associated mime type (null if not found)
          * @static 
          */
-        public static function get($key, $default = null){
+        public static function getMimeType($format){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::get($key, $default);
+            return \Illuminate\Http\Request::getMimeType($format);
         }
         
         /**
-         * Gets the Session.
+         * Gets the mime types associated with the format.
          *
-         * @return \Symfony\Component\HttpFoundation\SessionInterface|null The session
+         * @param string $format The format
+         * @return array The associated mime types
          * @static 
          */
-        public static function getSession(){
+        public static function getMimeTypes($format){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getSession();
+            return \Illuminate\Http\Request::getMimeTypes($format);
         }
         
         /**
-         * Whether the request contains a Session which was started in one of the
-         * previous requests.
+         * Gets the format associated with the mime type.
          *
-         * @return bool 
+         * @param string $mimeType The associated mime type
+         * @return string|null The format (null if not found)
          * @static 
          */
-        public static function hasPreviousSession(){
+        public static function getFormat($mimeType){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::hasPreviousSession();
+            return \Illuminate\Http\Request::getFormat($mimeType);
         }
         
         /**
-         * Whether the request contains a Session object.
+         * Associates a format with mime types.
+         *
+         * @param string $format The format
+         * @param string|array $mimeTypes The associated mime types (the preferred one must be the first as it will be used as the content type)
+         * @static 
+         */
+        public static function setFormat($format, $mimeTypes){
+            //Method inherited from \Symfony\Component\HttpFoundation\Request            
+            return \Illuminate\Http\Request::setFormat($format, $mimeTypes);
+        }
+        
+        /**
+         * Gets the request format.
          * 
-         * This method does not give any information about the state of the session object,
-         * like whether the session is started or not. It is just a way to check if this Request
-         * is associated with a Session instance.
+         * Here is the process to determine the format:
+         * 
+         *  * format defined by the user (with setRequestFormat())
+         *  * _format request attribute
+         *  * $default
          *
-         * @return bool true when the Request contains a Session object, false otherwise
+         * @param string $default The default format
+         * @return string The request format
          * @static 
          */
-        public static function hasSession(){
+        public static function getRequestFormat($default = 'html'){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::hasSession();
+            return \Illuminate\Http\Request::getRequestFormat($default);
         }
         
         /**
-         * Sets the Session.
+         * Sets the request format.
          *
-         * @param \Symfony\Component\HttpFoundation\SessionInterface $session The Session
+         * @param string $format The request format
          * @static 
          */
-        public static function setSession($session){
+        public static function setRequestFormat($format){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::setSession($session);
+            return \Illuminate\Http\Request::setRequestFormat($format);
         }
         
         /**
-         * Returns the client IP addresses.
-         * 
-         * In the returned array the most trusted IP address is first, and the
-         * least trusted one last. The "real" client IP address is the last one,
-         * but this is also the least trusted one. Trusted proxies are stripped.
-         * 
-         * Use this method carefully; you should use getClientIp() instead.
+         * Gets the format associated with the request.
          *
-         * @return array The client IP addresses
-         * @see getClientIp()
+         * @return string|null The format (null if no content type is present)
          * @static 
          */
-        public static function getClientIps(){
+        public static function getContentType(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getClientIps();
+            return \Illuminate\Http\Request::getContentType();
         }
         
         /**
-         * Returns the client IP address.
-         * 
-         * This method can read the client IP address from the "X-Forwarded-For" header
-         * when trusted proxies were set via "setTrustedProxies()". The "X-Forwarded-For"
-         * header value is a comma+space separated list of IP addresses, the left-most
-         * being the original client, and each successive proxy that passed the request
-         * adding the IP address where it received the request from.
-         * 
-         * If your reverse proxy uses a different header name than "X-Forwarded-For",
-         * ("Client-Ip" for instance), configure it via "setTrustedHeaderName()" with
-         * the "client-ip" key.
+         * Sets the default locale.
          *
-         * @return string The client IP address
-         * @see getClientIps()
-         * @see http://en.wikipedia.org/wiki/X-Forwarded-For
+         * @param string $locale
          * @static 
          */
-        public static function getClientIp(){
+        public static function setDefaultLocale($locale){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getClientIp();
+            return \Illuminate\Http\Request::setDefaultLocale($locale);
         }
         
         /**
-         * Returns current script name.
+         * Get the default locale.
          *
          * @return string 
          * @static 
          */
-        public static function getScriptName(){
+        public static function getDefaultLocale(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getScriptName();
+            return \Illuminate\Http\Request::getDefaultLocale();
         }
         
         /**
-         * Returns the path being requested relative to the executed script.
-         * 
-         * The path info always starts with a /.
-         * 
-         * Suppose this request is instantiated from /mysite on localhost:
-         * 
-         *  * http://localhost/mysite              returns an empty string
-         *  * http://localhost/mysite/about        returns '/about'
-         *  * http://localhost/mysite/enco%20ded   returns '/enco%20ded'
-         *  * http://localhost/mysite/about?var=1  returns '/about'
+         * Sets the locale.
          *
-         * @return string The raw path (i.e. not urldecoded)
+         * @param string $locale
          * @static 
          */
-        public static function getPathInfo(){
+        public static function setLocale($locale){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getPathInfo();
+            return \Illuminate\Http\Request::setLocale($locale);
         }
         
         /**
-         * Returns the root path from which this request is executed.
-         * 
-         * Suppose that an index.php file instantiates this request object:
-         * 
-         *  * http://localhost/index.php         returns an empty string
-         *  * http://localhost/index.php/page    returns an empty string
-         *  * http://localhost/web/index.php     returns '/web'
-         *  * http://localhost/we%20b/index.php  returns '/we%20b'
+         * Get the locale.
          *
-         * @return string The raw path (i.e. not urldecoded)
+         * @return string 
          * @static 
          */
-        public static function getBasePath(){
+        public static function getLocale(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getBasePath();
+            return \Illuminate\Http\Request::getLocale();
         }
         
         /**
-         * Returns the root URL from which this request is executed.
-         * 
-         * The base URL never ends with a /.
-         * 
-         * This is similar to getBasePath(), except that it also includes the
-         * script filename (e.g. index.php) if one exists.
+         * Checks if the request method is of specified type.
          *
-         * @return string The raw URL (i.e. not urldecoded)
+         * @param string $method Uppercase request method (GET, POST etc)
+         * @return bool 
          * @static 
          */
-        public static function getBaseUrl(){
+        public static function isMethod($method){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getBaseUrl();
+            return \Illuminate\Http\Request::isMethod($method);
         }
         
         /**
-         * Gets the request's scheme.
+         * Checks whether or not the method is safe.
          *
-         * @return string 
+         * @see https://tools.ietf.org/html/rfc7231#section-4.2.1
+         * @param bool $andCacheable Adds the additional condition that the method should be cacheable. True by default.
+         * @return bool 
          * @static 
          */
-        public static function getScheme(){
+        public static function isMethodSafe(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getScheme();
+            return \Illuminate\Http\Request::isMethodSafe();
         }
         
         /**
-         * Returns the port on which the request is made.
-         * 
-         * This method can read the client port from the "X-Forwarded-Port" header
-         * when trusted proxies were set via "setTrustedProxies()".
-         * 
-         * The "X-Forwarded-Port" header must contain the client port.
-         * 
-         * If your reverse proxy uses a different header name than "X-Forwarded-Port",
-         * configure it via "setTrustedHeaderName()" with the "client-port" key.
+         * Checks whether or not the method is idempotent.
          *
-         * @return string 
+         * @return bool 
          * @static 
          */
-        public static function getPort(){
+        public static function isMethodIdempotent(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getPort();
+            return \Illuminate\Http\Request::isMethodIdempotent();
         }
         
         /**
-         * Returns the user.
+         * Checks whether the method is cacheable or not.
          *
-         * @return string|null 
+         * @see https://tools.ietf.org/html/rfc7231#section-4.2.3
+         * @return bool 
          * @static 
          */
-        public static function getUser(){
+        public static function isMethodCacheable(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getUser();
+            return \Illuminate\Http\Request::isMethodCacheable();
         }
         
         /**
-         * Returns the password.
+         * Returns the request body content.
          *
-         * @return string|null 
+         * @param bool $asResource If true, a resource will be returned
+         * @return string|resource The request body content or a resource to read the body stream
+         * @throws \LogicException
          * @static 
          */
-        public static function getPassword(){
+        public static function getContent($asResource = false){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getPassword();
+            return \Illuminate\Http\Request::getContent($asResource);
         }
         
         /**
-         * Gets the user info.
+         * Gets the Etags.
          *
-         * @return string A user name and, optionally, scheme-specific information about how to gain authorization to access the server
+         * @return array The entity tags
          * @static 
          */
-        public static function getUserInfo(){
+        public static function getETags(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getUserInfo();
+            return \Illuminate\Http\Request::getETags();
         }
         
         /**
-         * Returns the HTTP host being requested.
          * 
-         * The port name will be appended to the host if it's non-standard.
          *
-         * @return string 
+         * @return bool 
          * @static 
          */
-        public static function getHttpHost(){
+        public static function isNoCache(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getHttpHost();
+            return \Illuminate\Http\Request::isNoCache();
         }
         
         /**
-         * Returns the requested URI (path and query string).
+         * Returns the preferred language.
          *
-         * @return string The raw URI (i.e. not URI decoded)
+         * @param array $locales An array of ordered available locales
+         * @return string|null The preferred locale
          * @static 
          */
-        public static function getRequestUri(){
+        public static function getPreferredLanguage($locales = null){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getRequestUri();
+            return \Illuminate\Http\Request::getPreferredLanguage($locales);
         }
         
         /**
-         * Gets the scheme and HTTP host.
-         * 
-         * If the URL was called with basic authentication, the user
-         * and the password are not added to the generated string.
+         * Gets a list of languages acceptable by the client browser.
          *
-         * @return string The scheme and HTTP host
+         * @return array Languages ordered in the user browser preferences
          * @static 
          */
-        public static function getSchemeAndHttpHost(){
+        public static function getLanguages(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getSchemeAndHttpHost();
+            return \Illuminate\Http\Request::getLanguages();
         }
         
         /**
-         * Generates a normalized URI (URL) for the Request.
+         * Gets a list of charsets acceptable by the client browser.
          *
-         * @return string A normalized URI (URL) for the Request
-         * @see getQueryString()
+         * @return array List of charsets in preferable order
          * @static 
          */
-        public static function getUri(){
+        public static function getCharsets(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getUri();
+            return \Illuminate\Http\Request::getCharsets();
         }
         
         /**
-         * Generates a normalized URI for the given path.
+         * Gets a list of encodings acceptable by the client browser.
          *
-         * @param string $path A path to use instead of the current one
-         * @return string The normalized URI for the path
+         * @return array List of encodings in preferable order
          * @static 
          */
-        public static function getUriForPath($path){
+        public static function getEncodings(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getUriForPath($path);
+            return \Illuminate\Http\Request::getEncodings();
         }
         
         /**
-         * Returns the path as relative reference from the current Request path.
-         * 
-         * Only the URIs path component (no schema, host etc.) is relevant and must be given.
-         * Both paths must be absolute and not contain relative parts.
-         * Relative URLs from one resource to another are useful when generating self-contained downloadable document archives.
-         * Furthermore, they can be used to reduce the link size in documents.
-         * 
-         * Example target paths, given a base path of "/a/b/c/d":
-         * - "/a/b/c/d"     -> ""
-         * - "/a/b/c/"      -> "./"
-         * - "/a/b/"        -> "../"
-         * - "/a/b/c/other" -> "other"
-         * - "/a/x/y"       -> "../../x/y"
+         * Gets a list of content types acceptable by the client browser.
          *
-         * @param string $path The target path
-         * @return string The relative target path
+         * @return array List of content types in preferable order
          * @static 
          */
-        public static function getRelativeUriForPath($path){
+        public static function getAcceptableContentTypes(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getRelativeUriForPath($path);
+            return \Illuminate\Http\Request::getAcceptableContentTypes();
         }
         
         /**
-         * Generates the normalized query string for the Request.
+         * Returns true if the request is a XMLHttpRequest.
          * 
-         * It builds a normalized query string, where keys/value pairs are alphabetized
-         * and have consistent escaping.
+         * It works if your JavaScript library sets an X-Requested-With HTTP header.
+         * It is known to work with common JavaScript frameworks:
          *
-         * @return string|null A normalized query string for the Request
+         * @see http://en.wikipedia.org/wiki/List_of_Ajax_frameworks#JavaScript
+         * @return bool true if the request is an XMLHttpRequest, false otherwise
          * @static 
          */
-        public static function getQueryString(){
+        public static function isXmlHttpRequest(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getQueryString();
+            return \Illuminate\Http\Request::isXmlHttpRequest();
         }
         
         /**
-         * Checks whether the request is secure or not.
-         * 
-         * This method can read the client protocol from the "X-Forwarded-Proto" header
-         * when trusted proxies were set via "setTrustedProxies()".
-         * 
-         * The "X-Forwarded-Proto" header must contain the protocol: "https" or "http".
+         * Indicates whether this request originated from a trusted proxy.
          * 
-         * If your reverse proxy uses a different header name than "X-Forwarded-Proto"
-         * ("SSL_HTTPS" for instance), configure it via "setTrustedHeaderName()" with
-         * the "client-proto" key.
+         * This can be useful to determine whether or not to trust the
+         * contents of a proxy-specific header.
          *
-         * @return bool 
+         * @return bool true if the request came from a trusted proxy, false otherwise
          * @static 
          */
-        public static function isSecure(){
+        public static function isFromTrustedProxy(){
             //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::isSecure();
+            return \Illuminate\Http\Request::isFromTrustedProxy();
         }
         
         /**
-         * Returns the host name.
-         * 
-         * This method can read the client host name from the "X-Forwarded-Host" header
-         * when trusted proxies were set via "setTrustedProxies()".
-         * 
-         * The "X-Forwarded-Host" header must contain the client host name.
-         * 
-         * If your reverse proxy uses a different header name than "X-Forwarded-Host",
-         * configure it via "setTrustedHeaderName()" with the "client-host" key.
+         * Determine if the given content types match.
          *
-         * @return string 
-         * @throws \UnexpectedValueException when the host name is invalid
+         * @param string $actual
+         * @param string $type
+         * @return bool 
          * @static 
          */
-        public static function getHost(){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getHost();
+        public static function matchesType($actual, $type){
+            return \Illuminate\Http\Request::matchesType($actual, $type);
         }
         
         /**
-         * Sets the request method.
+         * Determine if the request is sending JSON.
          *
-         * @param string $method
+         * @return bool 
          * @static 
          */
-        public static function setMethod($method){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::setMethod($method);
+        public static function isJson(){
+            return \Illuminate\Http\Request::isJson();
         }
         
         /**
-         * Gets the request "intended" method.
-         * 
-         * If the X-HTTP-Method-Override header is set, and if the method is a POST,
-         * then it is used to determine the "real" intended HTTP method.
-         * 
-         * The _method request parameter can also be used to determine the HTTP method,
-         * but only if enableHttpMethodParameterOverride() has been called.
-         * 
-         * The method is always an uppercased string.
+         * Determine if the current request probably expects a JSON response.
          *
-         * @return string The request method
-         * @see getRealMethod()
+         * @return bool 
          * @static 
          */
-        public static function getMethod(){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getMethod();
+        public static function expectsJson(){
+            return \Illuminate\Http\Request::expectsJson();
         }
         
         /**
-         * Gets the "real" request method.
+         * Determine if the current request is asking for JSON in return.
          *
-         * @return string The request method
-         * @see getMethod()
+         * @return bool 
          * @static 
          */
-        public static function getRealMethod(){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getRealMethod();
+        public static function wantsJson(){
+            return \Illuminate\Http\Request::wantsJson();
         }
         
         /**
-         * Gets the mime type associated with the format.
+         * Determines whether the current requests accepts a given content type.
          *
-         * @param string $format The format
-         * @return string The associated mime type (null if not found)
+         * @param string|array $contentTypes
+         * @return bool 
          * @static 
          */
-        public static function getMimeType($format){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getMimeType($format);
+        public static function accepts($contentTypes){
+            return \Illuminate\Http\Request::accepts($contentTypes);
         }
         
         /**
-         * Gets the mime types associated with the format.
+         * Return the most suitable content type from the given array based on content negotiation.
          *
-         * @param string $format The format
-         * @return array The associated mime types
+         * @param string|array $contentTypes
+         * @return string|null 
          * @static 
          */
-        public static function getMimeTypes($format){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getMimeTypes($format);
+        public static function prefers($contentTypes){
+            return \Illuminate\Http\Request::prefers($contentTypes);
         }
         
         /**
-         * Gets the format associated with the mime type.
+         * Determines whether a request accepts JSON.
          *
-         * @param string $mimeType The associated mime type
-         * @return string|null The format (null if not found)
+         * @return bool 
          * @static 
          */
-        public static function getFormat($mimeType){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getFormat($mimeType);
+        public static function acceptsJson(){
+            return \Illuminate\Http\Request::acceptsJson();
         }
         
         /**
-         * Associates a format with mime types.
+         * Determines whether a request accepts HTML.
          *
-         * @param string $format The format
-         * @param string|array $mimeTypes The associated mime types (the preferred one must be the first as it will be used as the content type)
+         * @return bool 
          * @static 
          */
-        public static function setFormat($format, $mimeTypes){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::setFormat($format, $mimeTypes);
+        public static function acceptsHtml(){
+            return \Illuminate\Http\Request::acceptsHtml();
         }
         
         /**
-         * Gets the request format.
-         * 
-         * Here is the process to determine the format:
-         * 
-         *  * format defined by the user (with setRequestFormat())
-         *  * _format request attribute
-         *  * $default
+         * Get the data format expected in the response.
          *
-         * @param string $default The default format
-         * @return string The request format
+         * @param string $default
+         * @return string 
          * @static 
          */
-        public static function getRequestFormat($default = 'html'){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getRequestFormat($default);
+        public static function format($default = 'html'){
+            return \Illuminate\Http\Request::format($default);
         }
         
         /**
-         * Sets the request format.
+         * Retrieve an old input item.
          *
-         * @param string $format The request format
+         * @param string $key
+         * @param string|array|null $default
+         * @return string|array 
          * @static 
          */
-        public static function setRequestFormat($format){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::setRequestFormat($format);
+        public static function old($key = null, $default = null){
+            return \Illuminate\Http\Request::old($key, $default);
         }
         
         /**
-         * Gets the format associated with the request.
+         * Flash the input for the current request to the session.
          *
-         * @return string|null The format (null if no content type is present)
+         * @return void 
          * @static 
          */
-        public static function getContentType(){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getContentType();
+        public static function flash(){
+            \Illuminate\Http\Request::flash();
         }
         
         /**
-         * Sets the default locale.
+         * Flash only some of the input to the session.
          *
-         * @param string $locale
+         * @param array|mixed $keys
+         * @return void 
          * @static 
          */
-        public static function setDefaultLocale($locale){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::setDefaultLocale($locale);
+        public static function flashOnly($keys){
+            \Illuminate\Http\Request::flashOnly($keys);
         }
         
         /**
-         * Get the default locale.
+         * Flash only some of the input to the session.
          *
-         * @return string 
+         * @param array|mixed $keys
+         * @return void 
          * @static 
          */
-        public static function getDefaultLocale(){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getDefaultLocale();
+        public static function flashExcept($keys){
+            \Illuminate\Http\Request::flashExcept($keys);
         }
         
         /**
-         * Sets the locale.
+         * Flush all of the old input from the session.
          *
-         * @param string $locale
+         * @return void 
          * @static 
          */
-        public static function setLocale($locale){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::setLocale($locale);
+        public static function flush(){
+            \Illuminate\Http\Request::flush();
         }
         
         /**
-         * Get the locale.
+         * Retrieve a server variable from the request.
          *
-         * @return string 
+         * @param string $key
+         * @param string|array|null $default
+         * @return string|array 
          * @static 
          */
-        public static function getLocale(){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getLocale();
+        public static function server($key = null, $default = null){
+            return \Illuminate\Http\Request::server($key, $default);
         }
         
         /**
-         * Checks if the request method is of specified type.
+         * Determine if a header is set on the request.
          *
-         * @param string $method Uppercase request method (GET, POST etc)
+         * @param string $key
          * @return bool 
          * @static 
          */
-        public static function isMethod($method){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::isMethod($method);
+        public static function hasHeader($key){
+            return \Illuminate\Http\Request::hasHeader($key);
         }
         
         /**
-         * Checks whether the method is safe or not.
+         * Retrieve a header from the request.
          *
-         * @return bool 
+         * @param string $key
+         * @param string|array|null $default
+         * @return string|array 
          * @static 
          */
-        public static function isMethodSafe(){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::isMethodSafe();
+        public static function header($key = null, $default = null){
+            return \Illuminate\Http\Request::header($key, $default);
         }
         
         /**
-         * Returns the request body content.
+         * Get the bearer token from the request headers.
          *
-         * @param bool $asResource If true, a resource will be returned
-         * @return string|resource The request body content or a resource to read the body stream
-         * @throws \LogicException
+         * @return string|null 
          * @static 
          */
-        public static function getContent($asResource = false){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getContent($asResource);
+        public static function bearerToken(){
+            return \Illuminate\Http\Request::bearerToken();
         }
         
         /**
-         * Gets the Etags.
+         * Determine if the request contains a given input item key.
          *
-         * @return array The entity tags
+         * @param string|array $key
+         * @return bool 
          * @static 
          */
-        public static function getETags(){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getETags();
+        public static function exists($key){
+            return \Illuminate\Http\Request::exists($key);
         }
         
         /**
-         * 
+         * Determine if the request contains a non-empty value for an input item.
          *
+         * @param string|array $key
          * @return bool 
          * @static 
          */
-        public static function isNoCache(){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::isNoCache();
+        public static function has($key){
+            return \Illuminate\Http\Request::has($key);
         }
         
         /**
-         * Returns the preferred language.
+         * Get all of the input and files for the request.
          *
-         * @param array $locales An array of ordered available locales
-         * @return string|null The preferred locale
+         * @return array 
          * @static 
          */
-        public static function getPreferredLanguage($locales = null){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getPreferredLanguage($locales);
+        public static function all(){
+            return \Illuminate\Http\Request::all();
         }
         
         /**
-         * Gets a list of languages acceptable by the client browser.
+         * Retrieve an input item from the request.
          *
-         * @return array Languages ordered in the user browser preferences
+         * @param string $key
+         * @param string|array|null $default
+         * @return string|array 
          * @static 
          */
-        public static function getLanguages(){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getLanguages();
+        public static function input($key = null, $default = null){
+            return \Illuminate\Http\Request::input($key, $default);
         }
         
         /**
-         * Gets a list of charsets acceptable by the client browser.
+         * Get a subset containing the provided keys with values from the input data.
          *
-         * @return array List of charsets in preferable order
+         * @param array|mixed $keys
+         * @return array 
          * @static 
          */
-        public static function getCharsets(){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getCharsets();
+        public static function only($keys){
+            return \Illuminate\Http\Request::only($keys);
         }
         
         /**
-         * Gets a list of encodings acceptable by the client browser.
+         * Get all of the input except for a specified array of items.
          *
-         * @return array List of encodings in preferable order
+         * @param array|mixed $keys
+         * @return array 
          * @static 
          */
-        public static function getEncodings(){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getEncodings();
+        public static function except($keys){
+            return \Illuminate\Http\Request::except($keys);
         }
         
         /**
-         * Gets a list of content types acceptable by the client browser.
+         * Intersect an array of items with the input data.
          *
-         * @return array List of content types in preferable order
+         * @param array|mixed $keys
+         * @return array 
          * @static 
          */
-        public static function getAcceptableContentTypes(){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getAcceptableContentTypes();
+        public static function intersect($keys){
+            return \Illuminate\Http\Request::intersect($keys);
         }
         
         /**
-         * Returns true if the request is a XMLHttpRequest.
-         * 
-         * It works if your JavaScript library sets an X-Requested-With HTTP header.
-         * It is known to work with common JavaScript frameworks:
+         * Retrieve a query string item from the request.
          *
-         * @link http://en.wikipedia.org/wiki/List_of_Ajax_frameworks#JavaScript
-         * @return bool true if the request is an XMLHttpRequest, false otherwise
+         * @param string $key
+         * @param string|array|null $default
+         * @return string|array 
          * @static 
          */
-        public static function isXmlHttpRequest(){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::isXmlHttpRequest();
+        public static function query($key = null, $default = null){
+            return \Illuminate\Http\Request::query($key, $default);
         }
         
         /**
-         * Indicates whether this request originated from a trusted proxy.
-         * 
-         * This can be useful to determine whether or not to trust the
-         * contents of a proxy-specific header.
+         * Determine if a cookie is set on the request.
          *
-         * @return bool true if the request came from a trusted proxy, false otherwise
+         * @param string $key
+         * @return bool 
          * @static 
          */
-        public static function isFromTrustedProxy(){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::isFromTrustedProxy();
+        public static function hasCookie($key){
+            return \Illuminate\Http\Request::hasCookie($key);
+        }
+        
+        /**
+         * Retrieve a cookie from the request.
+         *
+         * @param string $key
+         * @param string|array|null $default
+         * @return string|array 
+         * @static 
+         */
+        public static function cookie($key = null, $default = null){
+            return \Illuminate\Http\Request::cookie($key, $default);
+        }
+        
+        /**
+         * Get an array of all of the files on the request.
+         *
+         * @return array 
+         * @static 
+         */
+        public static function allFiles(){
+            return \Illuminate\Http\Request::allFiles();
+        }
+        
+        /**
+         * Determine if the uploaded data contains a file.
+         *
+         * @param string $key
+         * @return bool 
+         * @static 
+         */
+        public static function hasFile($key){
+            return \Illuminate\Http\Request::hasFile($key);
+        }
+        
+        /**
+         * Retrieve a file from the request.
+         *
+         * @param string $key
+         * @param mixed $default
+         * @return \Illuminate\Http\UploadedFile|array|null 
+         * @static 
+         */
+        public static function file($key = null, $default = null){
+            return \Illuminate\Http\Request::file($key, $default);
         }
         
         /**
